# Nano Banana 2 API

> Google-дың жылдам Gemini сурет моделі: жедел 0.5K нобайлардан 4K-ға дейін, экстремалды кадр пішімдері және веб арқылы негіздеу қолдауы бар.

Кескіндердегі мәтін мен бірнеше нысанды көріністерді жақсы өңдейтін, Nano Banana Pro моделінің жылдамырақ әрі арзанырақ нұсқасы. Шығыс 0.5K алдын ала көріністен 4K-ға дейін, ал кадр пішімдері баннерлер мен тік оқиғаларға арналған 1:8-ден 8:1-ге дейін. Қосымша веб-іздеу кескінді өзекті деректерге негіздейді, ал қосымша жоғары ойлау деңгейі күрделі орналасуларды салмас бұрын жоспарлайды. Бір сұрауға төрт кескінге дейін.

- Model id: `nano-banana-2`
- Made by: Google
- Category: Text to Image
- Output: image
- Price: from $0.06 / image (cheapest run $0.06 (60 API credits))
- Run: `POST https://api.doitong.com/v1/run/nano-banana-2`
- Quote: `POST https://api.doitong.com/v1/quote/nano-banana-2`
- Docs page: https://doitong.com/kk/developers/models/nano-banana-2

## Pricing

Price: **from $0.06 / image** (the lowest tier; the quote prices your exact input). Billed per generated image (`num_images`, default 1).

Price rules (the first rule that matches the input wins; a parameter you leave out counts as its default):

- When `enable_web_search` = true and `thinking_level` = high: by `resolution`, 0.5K: $0.077, 1K: $0.097, 2K: $0.137, 4K: $0.177 / image
- When `enable_web_search` = true: by `resolution`, 0.5K: $0.075, 1K: $0.095, 2K: $0.135, 4K: $0.175 / image
- When `thinking_level` = high: by `resolution`, 0.5K: $0.062, 1K: $0.082, 2K: $0.122, 4K: $0.162 / image

The full example input below costs $0.08 = 80 API credits (1 image × 80 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.com/v1/quote/nano-banana-2` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `prompt` |  | string | yes |  | 3 – 50000 characters | Кескін жасауға арналған мәтіндік нұсқаулар. |
| `num_images` | `num_outputs` | integer | no | `1` | 1 – 4 | Генерацияға сұралған кескіндер саны. |
| `seed` |  | integer \| null | no |  |  | Кездейсоқ сандар генерациясын бастайтын seed мәні. |
| `aspect_ratio` |  | enum (string) \| null | no | `auto` | `auto`, `21:9`, `16:9`, `3:2`, `4:3`, `5:4`, `1:1`, `4:5`, `3:4`, `2:3`, `9:16`, `4:1`, `1:4`, `8:1`, `1:8` | Жасалған кескіннің кадр пішімін нақты таңдаңыз: 4:1, 1:4, 8:1, 1:8 сияқты шеткі нұсқаларды таңдауға немесе модель кадр пішімін нұсқау негізінде таңдау үшін "auto" мәнін пайдалануға болады. |
| `output_format` |  | enum (string) | no | `png` | `jpeg`, `png`, `webp` | Нәтижедегі кескіннің файл пішімі. |
| `safety_tolerance` |  | enum (string) | no | `4` | `1`, `2`, `3`, `4`, `5`, `6` | Мазмұнды модерациялау төзімділігін ең жұмсақ 6 деңгейі мен ең қатаң, көп мазмұнды бұғаттайтын 1 деңгейі аралығында орнатады. |
| `system_prompt` |  | string | no | `` | ≤ 50000 characters | Сұрауға ортақ қосымша персона және шығыс стилі бойынша нұсқаулар. Олар Gemini-ге жүйелік нұсқау, ал OpenAI-үйлесімді провайдерлерге жүйелік хабарлама ретінде жіберіледі. Мән бос болса, бұл нұсқау үшін ештеңе жіберілмейді. |
| `resolution` |  | enum (string) | no | `1K` | `0.5K`, `1K`, `2K`, `4K` | Шығыс кескінінің ажыратымдылығы. |
| `limit_generations` |  | boolean | no | `true` |  | Қосылғанда сапаға әсер етуі мүмкін эксперименттік генерация шегі. `True` әр нұсқау раундын 1 генерациямен шектеп, нұсқаудағы кескін саны туралы нұсқауларды қайта анықтайды және модель жасаған аралық кескіндерді елемейді. |
| `enable_web_search` |  | boolean | no | `false` |  | Кескін генерациясына арналған веб-іздеу ауыстырғышы; модельге интернеттен алынған өзекті ақпаратты кескінге енгізуге мүмкіндік береді. |
| `thinking_level` |  | enum (string) \| null | no |  | `minimal`, `high` | Модельдің сол деңгейдегі ойлауын қосып, ойларын генерацияға енгізу үшін 'minimal' немесе 'high' таңдаңыз; деңгей көрсетілмесе, ойлау өшірулі қалады. |

## Example input

Required parameters only:

```json
{
  "prompt": "A cozy bookshop window at night with a hand-painted sign reading \"Open Late\", warm light, rain on the glass"
}
```

A fuller example:

```json
{
  "prompt": "A cozy bookshop window at night with a hand-painted sign reading \"Open Late\", warm light, rain on the glass",
  "aspect_ratio": "4:5",
  "resolution": "1K"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.com/v1/run/nano-banana-2?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "prompt": "A cozy bookshop window at night with a hand-painted sign reading \"Open Late\", warm light, rain on the glass",
    "aspect_ratio": "4:5",
    "resolution": "1K"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.com/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.com/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/nano-banana-2?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "prompt": "A cozy bookshop window at night with a hand-painted sign reading \"Open Late\", warm light, rain on the glass",
    "aspect_ratio": "4:5",
    "resolution": "1K"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.com/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "prompt": "A cozy bookshop window at night with a hand-painted sign reading \"Open Late\", warm light, rain on the glass",
    "aspect_ratio": "4:5",
    "resolution": "1K",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/nano-banana-2", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.com/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "nano-banana-2",
      "input": {
        "prompt": "A cozy bookshop window at night with a hand-painted sign reading \"Open Late\", warm light, rain on the glass",
        "aspect_ratio": "4:5",
        "resolution": "1K"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "nano-banana-2",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 80,
    "usd": "0.08",
    "charged": 80,
    "refunded": 0
  },
  "input": {
    "prompt": "A cozy bookshop window at night with a hand-painted sign reading \"Open Late\", warm light, rain on the glass",
    "aspect_ratio": "4:5",
    "resolution": "1K"
  },
  "output": {
    "images": [
      {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200,
        "width": 1024,
        "height": 768
      }
    ],
    "description": "string"
  },
  "outputs": [
    {
      "type": "image",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "width": 1024,
      "height": 768,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `images` | array of object {url, content_type, file_name, file_size, width, height} | Модель жасаған кескіндер. |
| `description` | string | Жасалған кескіндерге қоса берілетін сипаттама. |

## Related models

- [Nano Banana 2 Edit](https://doitong.com/developers/models/nano-banana-2/edit.md) (`nano-banana-2/edit`): from $0.06 / image
- [Nano Banana Pro](https://doitong.com/developers/models/nano-banana-pro.md) (`nano-banana-pro`): from $0.15 / image
- [FLUX.1 \[dev\]](https://doitong.com/developers/models/flux/dev.md) (`flux/dev`): $0.025 / megapixel
- [FLUX.1 \[schnell\]](https://doitong.com/developers/models/flux/schnell.md) (`flux/schnell`): $0.003 / megapixel
- [FLUX.2 \[dev\]](https://doitong.com/developers/models/flux-2.md) (`flux-2`): $0.012 / megapixel
- [FLUX.2 \[pro\]](https://doitong.com/developers/models/flux-2-pro.md) (`flux-2-pro`): $0.015 / megapixel of output image
- [GPT Image 2.5 Text to Image](https://doitong.com/developers/models/openai/gpt-image-2.5/flare/text-to-image.md) (`openai/gpt-image-2.5/flare/text-to-image`): from $0.008 / image
- [Ideogram V4.5](https://doitong.com/developers/models/ideogram/v4.5.md) (`ideogram/v4.5`): from $0.03 / image

## Links

- HTML page: https://doitong.com/developers/models/nano-banana-2
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=nano-banana-2
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.com/v1/models/nano-banana-2
